<!--
This component represents a person. Some more detailed information is show. All routes to and from work are requested and displayed using route components.
-->
<template>
    <div>
        <h3>{{detailed_person.name}}</h3>
        <table class="table table-striped">
            <tbody>
            <tr>
                <td >Email</td>
                <td >{{ detailed_person.email }}</td>
            </tr>
            <tr v-if="person">
                <td >Role</td>
                <td >{{ person.role_name }}</td>
            </tr>
            <tr v-if="detailed_person.address">
                <td >Address</td>
                <td >{{ detailed_person.address.line_1}} {{ detailed_person.address.line_2}} {{ detailed_person.address.zipcode}} {{ detailed_person.address.city}}</td>
            </tr>
            <tr v-if="person">
                <td >Weekly travel time</td>
                <td >{{ travel_time.hours() }}u {{travel_time.minutes()}}min</td>
            </tr>
            </tbody>
        </table>
        <div v-for="day in week" class="container" v-bind:key="day.morning.day()">
            <div class="row">
                <div class="col-xl-2">
                    <h4>{{day.morning.format("dddd")}}</h4>
                </div>
                <div class="col-xl-10">
                    <route v-if="day.morning_route" :route="day.morning_route"> </route>
                    <route v-if="day.evening_route" :route="day.evening_route"> </route>
                </div>
            </div>
        </div>

    </div>
</template>

<script>
  const HQ_LOCATION = {x:104289,y:192363};
  let moment = require('moment');
  import api from '../api/resources'
  import Route from './Route.vue'
  export default {
    name: 'PersonDetail',
    components: {
      Route
    },
    props: {
      person: Object
    },
    data() {
      return {
        detailed_person: {},
        week: [],
        travel_time: moment.duration(0)
      }
    },
    created() {
      api.load_employee(this.person.id).then(
        employee => {
          this.detailed_person = employee;
          this.week = this.create_week(this.detailed_person.weekly_time_engagement_minutes);
          api.address_to_lambert(this.detailed_person.address).then(
            location => this.get_routes(this.week,location)
          )
        });

    },
    methods: {
      add_travel_time(route){
        let d =moment.duration(route.duration.replace("u",":").slice(0,-3));
        this.travel_time.add(d);
      },

      get_routes(week,location){
        for(let i in week) {
          let day = week[i];
            api.route(location,HQ_LOCATION,day.morning,false).then(
              r => {
                if(r !== undefined) {
                  day.morning_route = r;
                  this.add_travel_time(r)
                }
              }
            );
            api.route(HQ_LOCATION,location,day.evening,true).then(
              r => {
                if(r !== undefined) {
                  day.evening_route = r;
                  this.add_travel_time(r)
                }
              }
            )
        }
      },



      create_week(weekly_time_engagement_minutes){
        let m = moment();
        m.hour(9);
        m.minutes(0);
        m.seconds(0);
        let week =[];

        for(let i=0;i<7;i++){
          let day = {morning_route:false,evening_route:false};
          day.morning = moment(m).day(i+7);

          let day_string = day.morning.format("dddd").toLowerCase();
          let minutes = weekly_time_engagement_minutes[day_string];

          day.evening = moment(day.morning).add(minutes,'minutes');

          if(minutes !== 0)  week.push(day);
        }
        return week;

      }

    }
  }
</script>